package soln;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Scanner;

import javax.swing.JFrame;

import packageForLT05.DotView;
import packageForLT05.DotModel;

import type.lang.UniPanel;

public class Labtest05_Sec02_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * [3 marks] Step 1: create an instance of a DotModel. Store the
		 * reference in a variable named "model". The API for this and other
		 * classes in this labtest can be found in the "doc" subdirectory of
		 * this package. You may use any valid in the constructor, but do not
		 * use a magic number. NB: your solution should work for *any* valid
		 * value and not just the one you select here.
		 */
		final int NUM_DOTS = 5;
		DotModel model = new DotModel(NUM_DOTS);

		/**
		 * [3 marks] Step 2: create an instance of a DotView. Use the
		 * appropriate constructor. Read the API carefully. You don't need to
		 * add the view to a JFrame. Just instantiate the view, compile and run
		 * the app.
		 * 
		 */
		DotView view = new DotView(model);

		/**
		 * [5 marks] Step 3: add code below so that the app repeatedly prompts
		 * the user for commands, in the same fashion as in DrawVersion6 (which
		 * has been included in the package "packageForLT05").
		 * 
		 * Offer the following commands:
		 * 
		 * "q" for quit - break out of the loop
		 * 
		 * "n" for "nudge all dots" - this means all dots will be nudged. You
		 * will need to iterate over all of the dots and nudge each one per
		 * iteration. (You have a representation of the total number of dots
		 * from Step 1 above.)
		 * 
		 * 
		 * The prompts should be as follows:
		 * "Command#1 [n=nudge all dots, q=quit]:"
		 * 
		 * For this step, it is suggested that you resize your eclipse window to
		 * a slightly narrower width and then reposition it to the right. That
		 * was, the GUI frame and the eclipse window will not overlap.
		 * 
		 */

		Scanner input = new Scanner(System.in);
		while (true) {
			System.out
					.println("Command#1 [n=nudge,d=change diameter, q=quit]:");
			String userInput = input.nextLine();
			if (userInput.equals("q")) {
				break;
			}
			if (userInput.equals("n")) {
				for (int i = 0; i < NUM_DOTS; i++) {
					model.nudgeToRight(i);
				}
			}
		}

		/**
		 * [3 marks] Step 4: add another loop below that offers the following
		 * commands:
		 * 
		 * "q" for quit - break out of the loop
		 * 
		 * "n" for "nudge all dots" - same as Step 3 above
		 * 
		 * "d" for "scale down diameter" - this means the diameter of all dots
		 * will be scaled down. You will need to iterate over all of the dots
		 * and modify the diameter of each one, one per iteration. (You have a
		 * representation of the total number of dots from Step 1 above.) Prompt
		 * the user for the scale down factor. A scale down factor of 2 means
		 * each dot's diameter should be cut in half, a scale down factor of 3
		 * means it should be cut in a third.
		 * 
		 * "u" for "scale up diameter" - same as scale down, except the scaling
		 * factor is the multiplier of the diameter.
		 * 
		 * 
		 * The prompts should be as follows:
		 * 
		 * "Command#2 [n=nudge all dots, d=scale down all dots, u=scale up all dots, q=quit]:"
		 * 
		 * "Scale down factor: "
		 * 
		 * "Scale up factor: "
		 */
		while (true) {
			System.out
					.println("Command#2 [n=nudge all dots, d=scale down all dots, u=scale up all dots, q=quit]:");
			String userInput = input.nextLine();
			if (userInput.equals("q")) {
				break;
			}
			if (userInput.equals("n")) {
				for (int i = 0; i < NUM_DOTS; i++) {
					model.nudgeToRight(i);
				}

			} else if (userInput.equals("d")) {
				System.out.println("Scale down factor: ");
				int scaleFactor = Integer.parseInt(input.nextLine());
				for (int i = 0; i < NUM_DOTS; i++) {
					int newDiameter = model.getDiameter(i) / scaleFactor;
					model.changeDiameter(i, newDiameter);
				}

			} else if (userInput.equals("u")) {
				System.out.println("Scale up factor: ");
				int scaleFactor = Integer.parseInt(input.nextLine());
				for (int i = 0; i < NUM_DOTS; i++) {
					int newDiameter = model.getDiameter(i) * scaleFactor;
					model.changeDiameter(i, newDiameter);
				}
			}

		}

	}
}
